/* @clake/react-bootstrap4-window v1.0.9 | by Clake
 * Copyright (c) 2024 Clake,
 * 2024-08-23T10:03:50+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CTable = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactBootstrap = require("@clake/react-bootstrap4");

require("./css/CTable.less");

var _Drag = _interopRequireDefault(require("./Drag"));

var _CTableInput = _interopRequireDefault(require("./CTableInput"));

var _CTable3 = _interopRequireDefault(require("./i18n/CTable"));

var _PageBar = _interopRequireDefault(require("./PageBar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var numberCondition = {
  '=': 'eq',
  '!=': 'ne',
  '>': 'gt',
  '>=': 'gte',
  '<=': 'lte',
  '<': 'lt'
};

var CTable = exports.CTable =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CTable, _React$Component);

  function CTable(props) {
    var _this$props$dataCount, _this$props$select;

    var _this;

    _classCallCheck(this, CTable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CTable).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "originalData", void 0);

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "select_all", void 0);

    _defineProperty(_assertThisInitialized(_this), "selectRows", void 0);

    _defineProperty(_assertThisInitialized(_this), "headerSplits", void 0);

    _defineProperty(_assertThisInitialized(_this), "sortList", void 0);

    _defineProperty(_assertThisInitialized(_this), "is_sort", void 0);

    _defineProperty(_assertThisInitialized(_this), "is_filter", void 0);

    _defineProperty(_assertThisInitialized(_this), "current_sort", void 0);

    _defineProperty(_assertThisInitialized(_this), "filter_list", void 0);

    _defineProperty(_assertThisInitialized(_this), "editRows", void 0);

    _defineProperty(_assertThisInitialized(_this), "cacheRow", void 0);

    _defineProperty(_assertThisInitialized(_this), "headers", void 0);

    _defineProperty(_assertThisInitialized(_this), "noClone", void 0);

    _defineProperty(_assertThisInitialized(_this), "lockColumns", void 0);

    _defineProperty(_assertThisInitialized(_this), "isLock", void 0);

    _defineProperty(_assertThisInitialized(_this), "filter", void 0);

    _defineProperty(_assertThisInitialized(_this), "width", void 0);

    _defineProperty(_assertThisInitialized(_this), "tableHeader", void 0);

    _defineProperty(_assertThisInitialized(_this), "tableTotal", void 0);

    _defineProperty(_assertThisInitialized(_this), "table_rows", void 0);

    _defineProperty(_assertThisInitialized(_this), "table_head", void 0);

    _defineProperty(_assertThisInitialized(_this), "table_body", void 0);

    _defineProperty(_assertThisInitialized(_this), "table_total", void 0);

    _defineProperty(_assertThisInitialized(_this), "fullButton", void 0);

    _defineProperty(_assertThisInitialized(_this), "split", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainMenu", void 0);

    _defineProperty(_assertThisInitialized(_this), "numMenu", void 0);

    _defineProperty(_assertThisInitialized(_this), "drag", void 0);

    _defineProperty(_assertThisInitialized(_this), "dragColumnLeft", void 0);

    _defineProperty(_assertThisInitialized(_this), "dragWidth", void 0);

    _defineProperty(_assertThisInitialized(_this), "allchk", void 0);

    _defineProperty(_assertThisInitialized(_this), "isFull", void 0);

    _defineProperty(_assertThisInitialized(_this), "equals", function (a, b) {
      if (a === b) return true;
      if (a instanceof Date && b instanceof Date) return a.getTime() === b.getTime();
      if (!a || !b || _typeof(a) !== 'object' && _typeof(b) !== 'object') return a === b;
      if (a.prototype !== b.prototype) return false;
      var keys = Object.keys(a);
      if (keys.length !== Object.keys(b).length) return false;
      return keys.every(function (k) {
        return _this.equals(a[k], b[k]);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "selectAll", function (checked) {
      _this.select_all = checked;
      var selectRows = [];

      if (checked) {
        _this.state.data.forEach(function (item, key) {
          selectRows.push(key);
        });
      }

      _this.setState({
        selectRows: selectRows,
        selectAll: checked,
        selectHalf: false
      }, function () {
        if (typeof _this.props.onCheckAll === 'function') {
          _this.props.onCheckAll(_this.state.selectAll, _this.state.data, _this.props.jsxId);
        }
      });
    });

    /**
     * sort
     */
    _defineProperty(_assertThisInitialized(_this), "sortHandler", function (e) {
      var dom = e.currentTarget;
      var sort_type = dom.dataset.sort || 'asc';

      _this.changeSort(dom, sort_type);
    });

    /**
     * scroll header and total foot
     * @param e
     */
    _defineProperty(_assertThisInitialized(_this), "scrollHandler", function (e) {
      _this.tableHeader.style.transform = "translateX(-".concat(e.currentTarget.scrollLeft, "px)"); // this.tableHeader.scrollLeft = e.currentTarget.scrollLeft;

      if (_this.tableTotal) {
        // this.tableTotal.scrollLeft = e.currentTarget.scrollLeft;
        _this.tableTotal.style.transform = "translateX(-".concat(e.currentTarget.scrollLeft, "px)");
      }
    });

    _defineProperty(_assertThisInitialized(_this), "menuClickHandler", function (field, data) {
      switch (field) {
        case "asc":
          _this.changeSort(document.querySelector("#".concat(_this.domId, "-sort-").concat(data.field)), 'asc');

          break;

        case "desc":
          _this.changeSort(document.querySelector("#".concat(_this.domId, "-sort-").concat(data.field)), 'desc');

          break;

        case "delete_row":
          _this.deleteRowHandler(parseInt(_this.mainMenu.data.index));

          break;

        case "clone_row":
          _this.cloneRow(parseInt(_this.mainMenu.data.index));

          break;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "selectPageHandler", function (page) {
      if (typeof _this.props.onSelectPage === 'function') {
        _this.props.onSelectPage(page, _this.props.jsxId);
      }
    });

    /**
     * edit mode
     */
    _defineProperty(_assertThisInitialized(_this), "addNewHandler", function (e) {
      var data = _this.state.data.slice(0);

      data.push(Object.assign({}, _this.cacheRow));

      _this.editRows.push(data.length - 1);

      _this.setState({
        data: data,
        dataCount: data.length
      }, function () {
        var _document$querySelect, _document$querySelect2, _document$querySelect3;

        (_document$querySelect = document.querySelector("#".concat(_this.domId, "-edit"))) === null || _document$querySelect === void 0 ? void 0 : (_document$querySelect2 = _document$querySelect.previousElementSibling) === null || _document$querySelect2 === void 0 ? void 0 : (_document$querySelect3 = _document$querySelect2.querySelector('input:not([disabled])')) === null || _document$querySelect3 === void 0 ? void 0 : _document$querySelect3.focus();
      });
    });

    //编辑事件
    _defineProperty(_assertThisInitialized(_this), "editHandler", function (e, val, row) {
      var dataset = row === 'chk' ? e.currentTarget.dataset : e.target.dataset;
      var index = parseInt(dataset.row);
      var field = dataset.field; //如果是check组件

      if (row === 'chk') {
        val = val ? 1 : 0;
      }

      if (_this.editRows.indexOf(index) === -1) {
        _this.editRows.push(index);

        var _data = _this.state.data.slice(0);

        _data[index][field] = val;

        _this.setState({
          data: _data
        });
      } else {
        _this.state.data[index][field] = val;
      }

      if (_this.headers[field] && typeof _this.headers[field].onEdit === 'function') {
        _this.headers[field].onEdit(index, val, row, _this.editCallback);
      }
    });

    //自定义 onEdit 事件回调函数
    _defineProperty(_assertThisInitialized(_this), "editCallback", function (index, editData) {
      if (_this.state.data[index]) {
        var _data2 = _this.state.data.slice(0);

        _data2[index] = Object.assign(_data2[index], editData);

        _this.setState({
          data: _data2
        });
      }
    });

    //全屏查看
    _defineProperty(_assertThisInitialized(_this), "fullHandler", function () {
      if (_this.isFull) {
        var _this$fullButton$quer, _this$fullButton$quer2;

        _this.mainDom.classList.remove('ck-ctable-full');

        (_this$fullButton$quer = _this.fullButton.querySelector('i')) === null || _this$fullButton$quer === void 0 ? void 0 : _this$fullButton$quer.classList.remove("fa-compress");
        (_this$fullButton$quer2 = _this.fullButton.querySelector('i')) === null || _this$fullButton$quer2 === void 0 ? void 0 : _this$fullButton$quer2.classList.add("fa-expand");
      } else {
        var _this$fullButton$quer3, _this$fullButton$quer4;

        _this.mainDom.classList.add('ck-ctable-full');

        (_this$fullButton$quer3 = _this.fullButton.querySelector('i')) === null || _this$fullButton$quer3 === void 0 ? void 0 : _this$fullButton$quer3.classList.add("fa-compress");
        (_this$fullButton$quer4 = _this.fullButton.querySelector('i')) === null || _this$fullButton$quer4 === void 0 ? void 0 : _this$fullButton$quer4.classList.remove("fa-expand");
      }

      _this.isFull = !_this.isFull;
    });

    _this.state = {
      data: _this.props.data || [],
      dataCount: (_this$props$dataCount = _this.props.dataCount) !== null && _this$props$dataCount !== void 0 ? _this$props$dataCount : 0,
      page: 1,
      select: (_this$props$select = _this.props.select) !== null && _this$props$select !== void 0 ? _this$props$select : false,
      total: _this.props.total,
      filter: {
        start: '',
        end: '',
        contain: ''
      },
      selectAll: false,
      //选中全部状态
      selectHalf: false,
      //半选中状态
      selectRows: [],
      //选中的数据列表
      focus: -1 //当前显示焦点

    };
    _this.originalData = _this.state.data.slice(0);
    _this.domId = 'table-' + _reactBootstrap.Common.RandomString(16);
    _this.select_all = false;
    _this.selectRows = [];
    _this.headerSplits = [];
    _this.sortList = {};
    _this.is_sort = typeof _this.props.onSort === 'function' || !!_this.props.sort;
    _this.is_filter = typeof _this.props.onFilter === 'function' || !!_this.props.filter;
    _this.current_sort = null;
    _this.filter_list = [];
    _this.filter = {};
    _this.editRows = [];
    _this.cacheRow = {}; //列头数据

    _this.headers = {}; //不需要克隆列

    _this.noClone = {};
    _this.lockColumns = []; //lock column flag

    _this.isLock = false;
    _this.isFull = false;

    _this.initTableWidth();

    return _this;
  }

  _createClass(CTable, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.bindSplit();
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.state.data !== nextProps.data) {
        var _nextProps$data, _nextProps$dataCount, _nextProps$page;

        if (this.props.edit) {
          if (this.equals(this.originalData, nextProps.data)) {
            return;
          }

          this.editRows = [];
        }

        this.originalData = _reactBootstrap.Common.Clone(nextProps.data); // if (this.allchk) {
        //     this.allchk.setHalf(false);
        //     this.selectRows = [];
        // }
        // this.select_all = false;
        // this.selectRows = [];

        var selectRows = [];
        var isHalf = false;
        var allchk = false;

        if (nextProps.data && nextProps.data.length > 0) {
          nextProps.data.forEach(function (item, idx) {
            if (item !== null && item !== void 0 && item.set_chk) {
              selectRows.push(idx);
            }
          });

          if (selectRows.length === nextProps.data.length) {
            allchk = true;
          } else {
            if (selectRows.length > 0) {
              isHalf = true;
            }
          }
        }

        this.setState({
          data: (_nextProps$data = nextProps.data) !== null && _nextProps$data !== void 0 ? _nextProps$data : [],
          dataCount: (_nextProps$dataCount = nextProps.dataCount) !== null && _nextProps$dataCount !== void 0 ? _nextProps$dataCount : 0,
          page: (_nextProps$page = nextProps.page) !== null && _nextProps$page !== void 0 ? _nextProps$page : 0,
          total: nextProps.total,
          selectRows: selectRows,
          selectHalf: isHalf,
          selectAll: allchk,
          focus: -1
        });
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextState.selectRows !== this.state.selectRows) {
        return true;
      }

      if (this.state.filter !== nextState.filter) {
        return true;
      }

      if (nextState.total !== this.state.total) {
        return true;
      }

      if (this.props.focus && nextState.focus !== this.state.focus) {
        return true;
      }

      return nextState.data !== this.state.data;
    }
  }, {
    key: "initTableWidth",
    value: function initTableWidth() {
      var _this2 = this;

      if (this.props.width) {
        var width = 0;
        var reg = /(\d+)(px|rem|cm|mm|pt)$/;
        var matchs = this.props.width.match(reg);
        var unit = matchs ? matchs[2] : 'px';

        _react["default"].Children.map(this.props.children, function (item, key) {
          if (item.props.width) {
            var _matchs = item.props.width.match(reg);

            width += parseInt(_matchs[1]);
            _this2.headers[item.props.field] = item.props;

            if (item.props.noClone) {
              _this2.noClone[item.props.field] = "";
            }
          }
        });

        if (this.props.select) {
          width += 20;
        }

        this.width = width + unit;
      }
    } //inner source ********************

  }, {
    key: "sourceLoad",
    value: function sourceLoad() {
      var _this3 = this;

      if (typeof this.props.sourceFunc !== 'function') return;
      this.props.sourceFunc({
        source: this.props.source,
        page: this.state.page,
        number: this.props.showNumbers
      }, function (res) {
        _this3.setState({
          data: res.data,
          dataCount: res.count,
          page: res.page
        });
      });
    }
  }, {
    key: "sourceFilter",
    value: function sourceFilter() {
      return this.filter_list.map(function (item) {
        switch (item.type) {
          case "start":
            return {
              field: item.field,
              value: "".concat(item.text, "%"),
              flag: 'like'
            };

          case "end":
            return {
              field: item.field,
              value: "%".concat(item.text),
              flag: 'like'
            };

          case "clear":
            // this.filter = {};
            break;

          case "":
            return {
              field: item.field,
              value: item.text,
              flag: '='
            };

          default:
            return {
              field: item.field,
              value: "%".concat(item.text, "%"),
              flag: 'like'
            };
        }
      });
    }
  }, {
    key: "sourceOrder",
    value: function sourceOrder() {} //innter source end ***************************
    //checkbox handler

  }, {
    key: "changeHandler",
    value: function changeHandler(row, i) {
      var _this4 = this;

      return function (checked, e) {
        var selectRows = _this4.setRowCheck(checked, i);

        var _this4$checkAllCheckH = _this4.checkAllCheckHalf(selectRows),
            _this4$checkAllCheckH2 = _slicedToArray(_this4$checkAllCheckH, 2),
            allChecked = _this4$checkAllCheckH2[0],
            half = _this4$checkAllCheckH2[1];

        _this4.setState({
          selectRows: selectRows,
          selectAll: allChecked,
          selectHalf: half
        });

        if (typeof _this4.props.onCheck === "function") {
          _this4.props.onCheck(checked, row, _this4.props.jsxId);
        }
      };
    }
  }, {
    key: "checkAllCheckHalf",
    value: function checkAllCheckHalf(selectRows) {
      if (!this.state.selectAll && this.props.selectOnce) {
        return [false, false];
      }

      if (selectRows.length > 0 && selectRows.length !== this.state.data.length) {
        return [false, true];
      }

      if (selectRows.length === 0) {
        return [false, false];
      } else if (selectRows.length === this.state.data.length) {
        return [true, false];
      }

      return [false, false];
    }
  }, {
    key: "setRowCheck",
    value: function setRowCheck(checked, rowIdx) {
      var selectRows = this.props.selectOnce ? [] : this.state.selectRows.slice();

      if (checked) {
        if (!selectRows.includes(rowIdx)) {
          selectRows.push(rowIdx);
        }
      } else {
        if (selectRows.includes(rowIdx)) {
          selectRows.splice(selectRows.indexOf(rowIdx), 1);
        }
      }

      return selectRows;
    }
  }, {
    key: "clickHandler",
    value: function clickHandler(row, i) {
      var _this5 = this;

      return function () {
        if (typeof _this5.props.onClick === 'function') {
          _this5.props.onClick(row, i, _this5.props.jsxId);
        }

        if (_this5.props.select && _this5.props.rowCheck) {
          var _row = _this5.refs['row_' + i];

          _row.changeHandler(null); // this.setRowCheck(!row.getChecked(),i);
          // this.checkAllCheckHalf();

        }

        if (_this5.props.focus) {
          _this5.setState({
            focus: i === _this5.state.focus ? -1 : i
          });
        }
      };
    }
  }, {
    key: "changeSort",
    value: function changeSort(dom, sort_type) {
      if (!dom) {
        return;
      }

      if (!dom.dataset.field) {
        return;
      }

      this.clearSort(false);
      this.current_sort = dom.dataset.field;
      dom.dataset.sort = sort_type === 'asc' ? 'desc' : 'asc';
      dom.classList.remove('ck-ctable-sort');
      this.sortList[dom.dataset.field] = sort_type;
      var child = dom.querySelector('i');

      if (!child) {
        return;
      }

      child.classList.remove('fa-sort', 'fa-sort-alpha-up', 'fa-sort-alpha-down');
      child.classList.add('fa-sort-alpha-' + (sort_type === 'asc' ? 'down' : 'up'));

      if (typeof this.props.onSort === 'function') {
        this.props.onSort(dom.dataset.field, sort_type, this.props.jsxId);
      } else {// this.localSort(dom.dataset.field,sort_type)
      }
    }
  }, {
    key: "clearSort",
    value: function clearSort(emitEvt) {
      if (this.current_sort) {
        var prv = document.querySelector("#".concat(this.domId, "-sort-").concat(this.current_sort));
        if (!prv) return;
        prv.dataset.sort = 'asc';
        prv.classList.add('ck-ctable-sort');
        var prv_child = prv.querySelector('i');
        if (!prv_child) return;
        prv_child.classList.remove('fa-sort', 'fa-sort-alpha-up', 'fa-sort-alpha-down');
        prv_child.classList.add('fa-sort');
        this.sortList[this.current_sort] = null;
        this.current_sort = null;

        if (emitEvt && typeof this.props.onSort === 'function') {
          this.props.onSort('', 'clear');
        } else {
          if (this.props.edit) {
            this.setState({
              data: this.originalData.slice(0)
            });
          }
        }

        return true;
      }

      return false;
    }
  }, {
    key: "localSort",
    value: function localSort(field, sort_type) {
      var desc = sort_type === 'desc';
      var data = this.state.data.slice(0);
      data.sort(function (a, b) {
        if (a[field] > b[field]) return desc ? -1 : 1;
        if (a[field] < b[field]) return desc ? 1 : -1;
        if (a[field] === b[field]) return 0;
        return 0;
      });
      this.setState({
        data: data
      });
    }
  }, {
    key: "menuContextHandler",

    /**
     * show menu list
     * @param dataType
     */
    value: function menuContextHandler(dataType) {
      var _this6 = this;

      return function (e) {
        e.preventDefault();
        e.stopPropagation();
        var data = {
          field: e.currentTarget.dataset.field || '',
          data: _this6.state.data[e.currentTarget.dataset.row],
          index: e.currentTarget.dataset.row
        };

        if (dataType === "text") {
          _this6.mainMenu.show({
            evt: e,
            type: 'mouse',
            data: data
          });
        } else {
          _this6.numMenu.show({
            evt: e,
            type: 'mouse',
            data: data
          });
        }
      };
    }
  }, {
    key: "localFilter",

    /**
     * filter
     * */
    value: function localFilter(text, field, type) {
      var reg;

      switch (type) {
        case "start":
          reg = new RegExp("^".concat(text));
          break;

        case "end":
          reg = new RegExp("".concat(text, "$"));
          break;

        default:
          reg = new RegExp("".concat(text));
      }

      var data = this.state.data.slice(0);
      var filter = [];
      data.forEach(function (item) {
        if (type === 'exclude') {
          if (!reg.test(item[field])) {
            filter.push(item);
          }
        } else {
          if (reg.test(item[field])) {
            filter.push(item);
          }
        }
      });
      this.setState({
        data: filter
      });
    }
  }, {
    key: "filterHandler",
    value: function filterHandler(text, field, type) {
      this.filter_list.push({
        text: text,
        field: field,
        type: type
      });
      this.setState({
        filter: {
          start: '',
          end: '',
          contain: '',
          condition: ''
        }
      });
      this.mainMenu.hide(undefined);
      this.numMenu.hide(undefined);

      if (typeof this.props.onFilter === 'function') {
        this.props.onFilter(text, field, type, this.props.jsxId);
      } else {
        this.localFilter(text, field, type);
      }
    }
  }, {
    key: "clearFilter",
    value: function clearFilter() {
      this.filter_list = [];
      var is_clean = this.clearSort(true);

      _reactBootstrap.Common.map(this.filter, function (item) {
        item.setValue('');
      });

      this.setState({
        filter: {
          start: '',
          end: '',
          contain: '',
          equal: ''
        }
      });

      if (typeof this.props.onFilter === 'function') {
        this.props.onFilter('', '', 'clear');
      } else {
        if (!is_clean) {
          this.setState({
            data: this.originalData.slice(0)
          });
        }
      }
    }
  }, {
    key: "filterChangeHandler",
    value: function filterChangeHandler(field) {
      var _this7 = this;

      return function (val) {
        var filter = _objectSpread({}, _this7.state.filter);

        filter[field] = val;

        _this7.setState({
          filter: filter
        });
      };
    }
  }, {
    key: "getEditRows",
    value: function getEditRows() {
      var list = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.editRows[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _row2 = _step.value;
          list.push(this.state.data[_row2]);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return list;
    }
  }, {
    key: "clearEditRows",
    value: function clearEditRows() {
      this.editRows = [];
    }
  }, {
    key: "deleteRowHandler",
    value: function deleteRowHandler(row_index) {
      if (row_index < 0 || row_index >= this.state.data.length) {
        return;
      }

      if (typeof this.props.onDelete === 'function') {
        this.props.onDelete(this.state.data[row_index], row_index, this.deleteRow, this.props.jsxId);
      } else {
        this.deleteRow(row_index);
      }
    }
  }, {
    key: "deleteRow",
    value: function deleteRow(row_index) {
      var _this8 = this;

      if (row_index < 0 || row_index >= this.state.data.length) {
        return;
      }

      var data = this.state.data.slice(0);
      data.splice(row_index, 1);

      if (this.editRows.indexOf(row_index) !== -1) {
        this.editRows.splice(this.editRows.indexOf(row_index), 1);
      }

      this.editRows.forEach(function (item, index) {
        if (item > row_index) {
          _this8.editRows[index] = item - 1;
        }
      });
      this.setState({
        data: data,
        dataCount: data.length
      });
    }
  }, {
    key: "cloneRow",
    value: function cloneRow(row_index) {
      if (row_index < 0 || row_index >= this.state.data.length) {
        return;
      }

      var data = this.state.data.slice(0);
      data.push(Object.assign({}, this.state.data[row_index], this.noClone));
      this.editRows.push(data.length - 1);
      this.setState({
        data: data,
        dataCount: data.length
      });
    }
  }, {
    key: "getSelectRows",
    //****************************

    /**
     * 得到所有选中的行
     */
    value: function getSelectRows() {
      var _this9 = this;

      return this.state.selectRows.map(function (item) {
        return _this9.state.data[item];
      });
    }
    /**
     * 设置选中的行
     */

  }, {
    key: "setSelectRows",
    value: function setSelectRows(key, list) {
      var selectRows = [];
      this.state.data.forEach(function (row, i) {
        if (list.includes(row[key])) {
          selectRows.push(i);
        }
      });
      var selectAll = selectRows.length > 1 && selectRows.length === this.state.data.length;
      this.setState({
        selectRows: selectRows,
        selectHalf: !selectAll,
        selectAll: selectAll
      });
    }
    /**
     * binding column split
     */

  }, {
    key: "bindSplit",
    value: function bindSplit() {
      var _this10 = this;

      if (this.props.move) {
        this.headerSplits.forEach(function (split) {
          if (!_this10.drag) {
            _this10.dragColumnLeft = 0;
            _this10.dragWidth = 0;
            _this10.drag = new _Drag["default"](_this10.split, split, {
              start: function start(dragDom, eventDom) {
                var xy = _reactBootstrap.Common.GetDomXY(eventDom, _this10.mainDom);

                _this10.dragWidth = parseInt((eventDom === null || eventDom === void 0 ? void 0 : eventDom.parentNode).style.width);
                _this10.dragColumnLeft = xy.left - _this10.table_rows.scrollLeft;
                dragDom.style.left = _this10.dragColumnLeft + 'px';
                dragDom.classList.remove('d-none');
                return true;
              },
              move: function move(_move, dragDom, eventDom) {
                if (_this10.dragWidth + (_move.x - _this10.dragColumnLeft) < 50) {
                  _move.x = _this10.dragColumnLeft - _this10.dragWidth + 50;
                }
              },
              end: function end(dragDom, eventDom) {
                dragDom.classList.add('d-none');
                var column_key = eventDom.dataset.key;

                var diff = parseInt(dragDom.style.left) - _this10.dragColumnLeft;

                _this10.width = parseInt(_this10.width) + diff + 'px';
                _this10.table_head.style.width = _this10.width;
                _this10.table_body.style.width = _this10.width;

                if (_this10.table_total) {
                  _this10.table_total.style.width = _this10.width;
                }

                document.querySelectorAll("#".concat(column_key)).forEach(function (item) {
                  item.style.width = "".concat(_this10.dragWidth + diff, "px");
                });
                return true;
              }
            });
          } else {
            _this10.drag.setEventDom(split);
          }
        });
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses(name) {
      var base = 'table ck-table';

      if (!!name) {
        base = (0, _classnames["default"])(base, name);
      } //striped


      if (this.props.striped && !this.props.edit) {
        base = (0, _classnames["default"])(base, 'table-striped');
      } //theme


      if (this.props.theme) {
        base = (0, _classnames["default"])(base, 'table-' + this.props.theme);
      } //bordered


      if (this.props.bordered) {
        base = (0, _classnames["default"])(base, 'table-bordered');
      } //hover


      if (this.props.hover) {
        base = (0, _classnames["default"])(base, 'table-hover');
      } //sm


      if (this.props.sm) {
        base = (0, _classnames["default"])(base, 'table-sm');
      }

      if (this.props.fontSm) {
        base = (0, _classnames["default"])(base, 'table-font-sm');
      } //responsive


      if (this.props.responsive) {
        base = (0, _classnames["default"])(base, 'table-responsive');
      } //nowrap


      if (this.props.noWrap) {
        base = (0, _classnames["default"])(base, 'ck-ctable-nowrap');
      }

      return base;
    }
  }, {
    key: "getMainClasses",
    value: function getMainClasses() {
      var base = 'ck-ctable-main d-flex flex-column';

      if (this.props.bordered) {
        base = (0, _classnames["default"])(base, 'border');
      }

      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      //default style
      var base = {}; //width

      if (this.props.width) {
        base.width = this.props.width;
      } //height


      if (this.props.height) {
        base.height = this.props.height;
      }

      if (this.props.absolute) {
        base.position = 'absolute';
        base.top = this.props.y;
        base.left = this.props.x;

        if (_typeof(this.props.position) === 'object') {
          base.top = this.props.position.top || this.props.y;
          base.left = this.props.position.left || this.props.x;
          base.right = this.props.position.right || 'unset';
          base.bottom = this.props.position.bottom || 'unset';

          if (this.props.position.left && this.props.position.right) {
            base.width = 'unset';
          }

          if (this.props.position.top && this.props.position.bottom) {
            base.height = 'unset';
          }
        }
      }

      return _reactBootstrap.Common.extend(base, this.props.style);
    }
  }, {
    key: "getHeaderClasses",
    value: function getHeaderClasses() {
      var base = 'ck-ctable-header';

      if (this.props.headerTheme) {
        base = (0, _classnames["default"])(base, 'table-' + this.props.headerTheme);
      }

      return (0, _classnames["default"])(base, this.props.headClass);
    }
  }, {
    key: "getTableStyles",
    value: function getTableStyles(style) {
      var base = {};

      if (this.width) {
        base.width = this.width;
      }

      if (style) {
        base = Object.assign({}, base, style);
      }

      return base;
    }
  }, {
    key: "getBodyClasses",
    value: function getBodyClasses() {
      var base = 'ck-ctable-body flex-grow-1 d-flex flex-column';
      return base;
    }
  }, {
    key: "calcLocalTotal",
    value: function calcLocalTotal(field) {
      var _this11 = this;

      return function (e) {
        var list = _this11.state.data;
        var total = 0;
        list.forEach(function (item) {
          if (!!parseFloat(item[field])) {
            total += parseFloat(item[field]);
          }
        });
        var totalData = Object.assign({}, _this11.state.total);
        totalData[field] = total.toFixed(2);

        _this11.setState({
          total: totalData
        });
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this12 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this12.mainDom = c;
        },
        className: this.getMainClasses(),
        style: this.getStyles()
      }, _react["default"].createElement("div", {
        className: this.getBodyClasses()
      }, this.renderHeader(), this.renderRows(), this.renderTotal(), _react["default"].createElement(_reactBootstrap.Scroll, {
        selector: "#table-body-com-".concat(this.domId)
      }), _react["default"].createElement(_reactBootstrap.HScroll, {
        selector: "#table-body-com-".concat(this.domId)
      })), this.renderFoot(), _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this12.split = c;
        },
        className: "ck-split d-none"
      }));
    }
  }, {
    key: "renderHeader",
    value: function renderHeader() {
      var _this13 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this13.tableHeader = c;
        }
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this13.table_head = c;
        },
        id: "table-head-".concat(this.domId),
        className: this.getClasses(''),
        style: this.getTableStyles(null)
      }, _react["default"].createElement("thead", {
        className: this.getHeaderClasses()
      }, _react["default"].createElement("tr", null, this.state.select || this.props.edit ? _react["default"].createElement("th", {
        style: {
          width: '20px',
          textAlign: 'center'
        }
      }, this.props.edit || this.props.selectOnce ? _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "list"
      }) : _react["default"].createElement(_reactBootstrap.CCheckbox, {
        ref: function ref(c) {
          return _this13.allchk = c;
        },
        onChange: this.selectAll,
        checked: this.state.selectAll,
        half: this.state.selectHalf
      })) : null, _react["default"].Children.map(this.props.children, function (item, key) {
        _this13.cacheRow[item.props.field] = '';

        if (!item || item.props.hide) {
          return null;
        } // let align = item.props.align || this.props.align;


        var style = {
          'textAlign': 'center'
        };

        if (item.props.width) {
          style.width = item.props.width;
        }

        var sort_icon = '';

        if (_this13.sortList[item.props.field]) {
          sort_icon = 'sort-alpha-' + (_this13.sortList[item.props.field] === 'asc' ? 'down' : 'up');
        }

        return _react["default"].createElement("th", {
          onContextMenu: _this13.menuContextHandler(''),
          id: _this13.domId + '-' + key,
          "data-key": 'head_' + key,
          style: style
        }, _this13.is_sort ? _react["default"].createElement("a", {
          className: "ck-ctable-sort",
          href: "javascript://",
          id: "".concat(_this13.domId, "-sort-").concat(item.props.field),
          "data-field": item.props.field,
          onClick: _this13.sortHandler
        }, item.props.text, " ", _react["default"].createElement(_reactBootstrap.Icon, {
          icon: sort_icon
        })) : item.props.text, _this13.props.move ? _react["default"].createElement("span", {
          ref: function ref(c) {
            return _this13.headerSplits.push(c);
          },
          "data-key": _this13.domId + '-' + key,
          className: "ck-column-split"
        }) : null);
      })))));
    }
  }, {
    key: "renderRows",
    value: function renderRows() {
      var _this14 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this14.table_rows = c;
        },
        id: "table-body-com-".concat(this.domId),
        className: "flex-grow-1 rows",
        onScroll: this.scrollHandler
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this14.table_body = c;
        },
        id: "table-body-".concat(this.domId),
        className: this.getClasses(),
        style: this.getTableStyles()
      }, _react["default"].createElement("tbody", null, this.state.data.map(function (row, i) {
        if (_this14.props.edit) {
          return _this14.renderEditRow(row, i);
        }

        return _this14.renderRow(row, i, null);
      }), this.props.edit && this.props.newBar ? this.renderEditAddRow() : null)), this.props.menu ? this.renderMenu() : null, this.props.menu ? this.renderNumberMenu() : null);
    }
  }, {
    key: "renderRow",
    value: function renderRow(row, i, parentRow) {
      var _this15 = this;

      var checked = this.state.selectRows.indexOf(i) !== -1;
      var focus = i === this.state.focus && this.props.focus;
      var rowClass = focus ? 'ck-table-focus' : checked ? 'ck-table-selected' : undefined;
      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("tr", {
        className: rowClass,
        onClick: this.clickHandler(row, i)
      }, this.state.select ? _react["default"].createElement("th", {
        style: {
          width: '20px',
          textAlign: 'center'
        }
      }, _react["default"].createElement(_reactBootstrap.CCheckbox, {
        ref: 'row_' + i,
        onChange: this.changeHandler(row, i),
        checked: checked
      })) : null, _react["default"].Children.map(this.props.children, function (item, key) {
        if (!item || item.props.hide) {
          return null;
        } //set style


        var style = _objectSpread({}, _this15.props.columnStyle);

        style.textAlign = item.props.align || _this15.props.align;

        if (item.props.width) {
          style.width = item.props.width;
        } //set color


        if (item.props.color) {
          style.color = item.props.color;
        }

        if (item.props.bgColor) {
          style.backgroundColor = item.props.bgColor;
        }

        var dataType;

        switch (item.props.dataType) {
          case "number":
            dataType = "number";
            break;

          case "date":
            dataType = "date";
            break;

          default:
            dataType = "text";
        }

        if (item.props.children) {
          return _react["default"].createElement("td", {
            onContextMenu: _this15.menuContextHandler(dataType),
            id: _this15.domId + '-' + key,
            "data-row": "".concat(i),
            "data-field": item.props.field,
            className: item.props.className,
            key: 'col_' + key
          }, _react["default"].cloneElement(item, {
            text: item.props.text,
            row: row,
            value: row[item.props.field]
          }));
        } else {
          if (item.props.type) {
            item.props.disabled = true;
          }

          return _react["default"].createElement("td", {
            onContextMenu: _this15.menuContextHandler(dataType),
            id: _this15.domId + '-' + key,
            "data-field": item.props.field,
            style: style,
            onClick: function onClick(e) {
              if (typeof item.props.onClick === 'function') {
                item.props.onClick(row);
              }
            },
            onDoubleClick: function onDoubleClick(e) {
              if (typeof item.props.onDoubleClick === 'function') {
                item.props.onDoubleClick(row);
              }
            },
            "data-row": "".concat(i)
          }, item.props.type ? _this15.renderEditComponent(item.props, row, i) : item.props.onFormat ? item.props.onFormat(row[item.props.field], row, item.props.field) : row[item.props.field]);
        }
      })));
    }
  }, {
    key: "renderEditRow",
    value: function renderEditRow(row, i) {
      var _this16 = this;

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("tr", {
        className: this.props.onClick ? 'click-row' : undefined,
        onClick: this.clickHandler(row, i)
      }, _react["default"].createElement("th", {
        style: {
          width: '20px',
          textAlign: 'center'
        }
      }, this.editRows.indexOf(i) === -1 ? null : _react["default"].createElement(_reactBootstrap.Icon, {
        id: "".concat(this.domId, "-edit-row-icon-").concat(i),
        icon: "edit",
        className: "text-danger"
      })), _react["default"].Children.map(this.props.children, function (item, key) {
        if (!item || item.props.hide) {
          return null;
        } //set style


        var style = _objectSpread({}, _this16.props.columnStyle);

        style.textAlign = item.props.align || _this16.props.align;

        if (item.props.width) {
          style.width = item.props.width;
        }

        var dataType = 'text';
        return _react["default"].createElement("td", {
          onContextMenu: _this16.menuContextHandler(dataType),
          className: item.props.disabled ? 'disabled' : '',
          id: _this16.domId + '-' + key,
          "data-field": item.props.field,
          style: style,
          onClick: function onClick(e) {
            if (typeof item.props.onClick === 'function') {
              item.props.onClick(row);
            }
          },
          onDoubleClick: function onDoubleClick(e) {
            if (typeof item.props.onDoubleClick === 'function') {
              item.props.onDoubleClick(row);
            }
          },
          "data-row": "".concat(i)
        }, item.props.disabled ? item.props.onFormat ? item.props.onFormat(row[item.props.field], row, item.props.field) : row[item.props.field] : _this16.renderEditComponent(item.props, row, i));
      })));
    }
  }, {
    key: "renderEditAddRow",
    value: function renderEditAddRow() {
      var _this17 = this;

      return _react["default"].createElement("tr", {
        id: this.domId + '-edit'
      }, _react["default"].createElement("th", {
        style: {
          width: '20px',
          textAlign: 'center'
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "chevron-circle-right"
      })), _react["default"].Children.map(this.props.children, function (item, key) {
        if (!item || item.props.hide) {
          return null;
        }

        var style = {
          width: item.props.width
        };
        return _react["default"].createElement("td", {
          style: style
        }, _react["default"].createElement(_CTableInput["default"], {
          onFocus: _this17.addNewHandler
        }));
      }));
    }
  }, {
    key: "renderEditComponent",
    value: function renderEditComponent(item, row, i) {
      var _this18 = this;

      switch (item.type) {
        case "combo":
          return _react["default"].createElement(_CTableInput["default"], {
            onChange: this.editHandler,
            "data-row": i,
            "data-field": item.field,
            data: row[item.field],
            align: item.align,
            disabled: item.disabled,
            combo: item.combo,
            comboData: item.comboData
          });

        case "calendar":
          return _react["default"].createElement(_CTableInput["default"], {
            onChange: this.editHandler,
            "data-row": i,
            "data-field": item.field,
            data: row[item.field],
            align: item.align,
            disabled: item.disabled,
            calendarFormat: item.calendarFormat,
            calendar: true
          });

        case "checkbox":
          return _react["default"].createElement(_reactBootstrap.CCheckbox, {
            className: "d-inline",
            width: "20px",
            onChange: function onChange(chk, e) {
              _this18.editHandler(e, chk, 'chk');
            },
            "data-row": i,
            "data-field": item.field,
            checked: !!row[item.field],
            disabled: item.disabled,
            tabIndex: "0"
          });

        default:
          return _react["default"].createElement(_CTableInput["default"], {
            onChange: this.editHandler,
            "data-row": i,
            "data-field": item.field,
            data: row[item.field],
            align: item.align,
            disabled: item.disabled,
            onBlur: this.state.total && this.state.total.hasOwnProperty(item.field) ? this.calcLocalTotal(item.field) : undefined
          });
      }
    }
  }, {
    key: "renderFoot",
    value: function renderFoot() {
      var _this$props$showNumbe,
          _this$props$showPages,
          _this$props$edit,
          _this19 = this;

      if (!this.props.foot) {
        return null;
      }

      return _react["default"].createElement("div", {
        className: "ck-ctable-foot d-flex align-items-center"
      }, _react["default"].createElement(_PageBar["default"], {
        page: this.state.page,
        dataCount: this.state.dataCount,
        onSelect: this.selectPageHandler,
        showNumbers: (_this$props$showNumbe = this.props.showNumbers) !== null && _this$props$showNumbe !== void 0 ? _this$props$showNumbe : 0,
        showPages: (_this$props$showPages = this.props.showPages) !== null && _this$props$showPages !== void 0 ? _this$props$showPages : 0,
        noPage: (_this$props$edit = this.props.edit) !== null && _this$props$edit !== void 0 ? _this$props$edit : false
      }), _react["default"].createElement("div", {
        ref: function ref(c) {
          _this19.fullButton = c;
        },
        className: "full-btn align-self-center ms-auto pe-2 text-primary",
        onClick: function onClick() {
          _this19.fullHandler();
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "expand"
      })));
    }
  }, {
    key: "renderTotal",
    value: function renderTotal() {
      var _this20 = this;

      if (!this.state.total) {
        return null;
      }

      var total = this.state.total;
      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this20.tableTotal = c;
        },
        className: "ck-ctable-total"
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this20.table_total = c;
        },
        id: "table-total-".concat(this.domId),
        className: this.getClasses(),
        style: this.getTableStyles()
      }, _react["default"].createElement("tbody", null, _react["default"].createElement("tr", null, this.state.select || this.props.edit ? _react["default"].createElement("td", {
        width: "20px"
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "chart-line"
      })) : null, _react["default"].Children.map(this.props.children, function (item, key) {
        if (!item || item.props.hide) {
          return null;
        }

        var align = item.props.align || _this20.props.align;
        var style = {
          'textAlign': align
        };

        if (item.props.width) {
          style.width = item.props.width;
        }

        return _react["default"].createElement("td", {
          id: _this20.domId + '-' + key,
          "data-field": item.props.field,
          style: style
        }, item.props.onFormat ? item.props.onFormat(total[item.props.field], total, item.props.field) : total[item.props.field]);
      })))));
    }
  }, {
    key: "renderMenu",
    value: function renderMenu() {
      var _this21 = this;

      var lang;

      if (!this.props.lang) {
        var i18 = _reactBootstrap.i18n.getLang();

        var langStr = typeof lang === 'string' ? lang : i18["short"];
        lang = _CTable3["default"][langStr];
      } else {
        if (typeof this.props.lang === 'string') {
          lang = _CTable3["default"][this.props.lang];
        } else {
          lang = this.props.lang;
        }
      }

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_reactBootstrap.Menu, {
        ref: function ref(c) {
          return _this21.mainMenu = c;
        },
        onClick: this.menuClickHandler
      }, _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "copy",
        onClick: function onClick() {
          document.execCommand("copy");
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "me-1",
        icon: "copy"
      }), lang['Copy']), this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "",
        step: true
      }) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "select_filter",
        onClick: function onClick(e, field, data) {
          var select = document.getSelection();
          if (!select) return;

          _this21.filterHandler(select.toString(), data.field, 'contain');
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "me-1",
        icon: "filter"
      }), lang['Filter By Selection']) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "select_exclude",
        onClick: function onClick(e, field, data) {
          var select = document.getSelection();
          if (!select) return;

          _this21.filterHandler(select.toString(), data.field, 'exclude');
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "me-1",
        icon: "filter"
      }), lang['Filter Excluding Selection']) : null, this.is_filter || this.is_sort ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "clear_filter",
        onClick: function onClick() {
          _this21.clearFilter();
        }
      }, _react["default"].createElement("span", {
        className: "text-danger"
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "me-1",
        icon: "brush"
      }), lang['Clear Filter / Sort'])) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "",
        step: true
      }) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "equal"
      }, this.state.filter.equal, _react["default"].createElement("span", {
        className: "me-1",
        style: inputStyle
      }, lang['Equal With']), _react["default"].createElement(_reactBootstrap.Input, {
        ref: function ref(c) {
          return _this21.filter.equal = c;
        },
        className: "me-1",
        size: "xs",
        width: "120px",
        data: this.state.filter.equal,
        onChange: this.filterChangeHandler('equal'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          _this21.filterHandler(_this21.state.filter.equal, _this21.mainMenu.data.field, 'equal');
        }
      }), _react["default"].createElement(_reactBootstrap.Button, {
        size: "xs",
        onMouseDown: stopEvent,
        onClick: function onClick(e) {
          _this21.filterHandler(_this21.state.filter.equal, _this21.mainMenu.data.field, 'equal');
        },
        icon: "search"
      })) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "filter"
      }, _react["default"].createElement("span", {
        className: "me-1",
        style: inputStyle
      }, lang['Start With']), _react["default"].createElement(_reactBootstrap.Input, {
        ref: function ref(c) {
          return _this21.filter.start = c;
        },
        className: "me-1",
        size: "xs",
        width: "120px",
        data: this.state.filter.start,
        onChange: this.filterChangeHandler('start'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          _this21.filterHandler(_this21.state.filter.start, _this21.mainMenu.data.field, 'start');
        }
      }), _react["default"].createElement(_reactBootstrap.Button, {
        size: "xs",
        onMouseDown: stopEvent,
        onClick: function onClick(e) {
          _this21.filterHandler(_this21.state.filter.start, _this21.mainMenu.data.field, 'start');
        },
        icon: "search"
      })) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "filter"
      }, _react["default"].createElement("span", {
        className: "me-1",
        style: inputStyle
      }, lang['End With']), _react["default"].createElement(_reactBootstrap.Input, {
        ref: function ref(c) {
          return _this21.filter.end = c;
        },
        className: "me-1",
        size: "xs",
        width: "120px",
        data: this.state.filter.end,
        onChange: this.filterChangeHandler('end'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          _this21.filterHandler(_this21.state.filter.end, _this21.mainMenu.data.field, 'end');
        }
      }), _react["default"].createElement(_reactBootstrap.Button, {
        size: "xs",
        onMouseDown: stopEvent,
        onClick: function onClick(e) {
          _this21.filterHandler(_this21.state.filter.end, _this21.mainMenu.data.field, 'end');
        },
        icon: "search"
      })) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "filter"
      }, _react["default"].createElement("span", {
        className: "me-1",
        style: inputStyle
      }, lang['Contain with']), _react["default"].createElement(_reactBootstrap.Input, {
        ref: function ref(c) {
          return _this21.filter.contain = c;
        },
        className: "me-1",
        size: "xs",
        width: "120px",
        data: this.state.filter.contain,
        onChange: this.filterChangeHandler('contain'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          _this21.filterHandler(_this21.state.filter.contain, _this21.mainMenu.data.field, 'contain');
        }
      }), _react["default"].createElement(_reactBootstrap.Button, {
        size: "xs",
        onMouseDown: stopEvent,
        onClick: function onClick(e) {
          _this21.filterHandler(_this21.state.filter.contain, _this21.mainMenu.data.field, 'contain');
        },
        icon: "search"
      })) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "",
        step: true
      }) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "filter",
        className: "flex-column"
      }, _react["default"].createElement("div", {
        className: "w-100"
      }, lang['Condition Filter']), _react["default"].createElement(_reactBootstrap.Input, {
        size: "xs",
        width: "100%",
        data: this.state.filter.condition,
        onChange: this.filterChangeHandler('condition'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          _this21.filterHandler(_this21.state.filter.condition, _this21.mainMenu.data.field, 'condition');
        }
      })) : null, this.props.edit && (!this.props.nodel || this.props.newBar) ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "",
        step: true
      }) : null, this.props.edit && !this.props.nodel ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "delete_row"
      }, lang['Delete Row']) : null, this.props.edit && this.props.newBar ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "clone_row"
      }, lang['Clone Row']) : null, this.props.customMenu ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "",
        step: true
      }) : null, this.props.customMenu ? this.props.customMenu.map(function (menu) {
        return _this21.explainCustomMenu(menu);
      }) : null));
    } // MARK:-生成数字菜单

  }, {
    key: "renderNumberMenu",
    value: function renderNumberMenu() {
      var _this22 = this;

      var lang;

      if (!this.props.lang) {
        var i18 = _reactBootstrap.i18n.getLang();

        var langStr = typeof lang === 'string' ? lang : i18["short"];
        lang = _CTable3["default"][langStr];
      } else {
        if (typeof this.props.lang === 'string') {
          lang = _CTable3["default"][this.props.lang];
        } else {
          lang = this.props.lang;
        }
      }

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_reactBootstrap.Menu, {
        ref: function ref(c) {
          return _this22.numMenu = c;
        },
        onClick: this.menuClickHandler
      }, _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "copy",
        onClick: function onClick() {
          document.execCommand("copy");
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "me-1",
        icon: "copy"
      }), lang['Copy']), this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "",
        step: true
      }) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "select_filter",
        onClick: function onClick(e, field, data) {
          var select = document.getSelection();
          if (!select) return;

          _this22.filterHandler(select.toString(), data.field, 'contain');
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "me-1",
        icon: "filter"
      }), lang['Filter By Selection']) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "select_exclude",
        onClick: function onClick(e, field, data) {
          var select = document.getSelection();
          if (!select) return;

          _this22.filterHandler(select.toString(), data.field, 'exclude');
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "me-1",
        icon: "filter"
      }), lang['Filter Excluding Selection']) : null, this.is_filter || this.is_sort ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "clear_filter",
        onClick: function onClick() {
          _this22.clearFilter();
        }
      }, _react["default"].createElement("span", {
        className: "text-danger"
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "me-1",
        icon: "brush"
      }), lang['Clear Filter / Sort'])) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "",
        step: true
      }) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "filter",
        className: "flex-column"
      }, _react["default"].createElement("div", {
        className: "w-100"
      }, lang['Condition Filter']), _react["default"].createElement(_reactBootstrap.Input, {
        size: "xs",
        width: "100%",
        data: this.state.filter.condition,
        onChange: this.filterChangeHandler('condition'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          var reg = /(>=|<=|<|>|=|!=)+\s*(\d+)/i;
          var m = String(_this22.state.filter.condition).match(reg);

          if (m) {
            _this22.filterHandler(m[2], _this22.numMenu.data.field, numberCondition[m[1]]);
          } else {
            _this22.filterHandler(_this22.state.filter.condition, _this22.numMenu.data.field, 'condition');
          }
        }
      }), _react["default"].createElement("div", null, "and,or,between,>,>=,<,<=,=")) : null));
    }
  }, {
    key: "explainCustomMenu",
    value: function explainCustomMenu(menu) {
      var _this23 = this;

      if (menu.children && menu.children instanceof Array) {
        return _react["default"].createElement(_reactBootstrap.Menu.Item, {
          field: menu.field,
          text: menu.text,
          child: true
        }, menu.children.map(function (item) {
          return _this23.explainCustomMenu(item);
        }));
      } else {
        return _react["default"].createElement(_reactBootstrap.Menu.Item, {
          field: menu.field,
          onClick: menu.click
        }, menu.text);
      }
    }
  }]);

  return CTable;
}(_react["default"].Component);

_defineProperty(CTable, "defaultProps", {
  data: [],
  dataCount: 1,
  select: true,
  header: true,
  foot: true,
  currentPage: 1,
  hover: true,
  striped: true,
  align: 'left',
  sm: true,
  fontSm: true,
  headerTheme: 'primary',
  noWrap: true,
  bordered: true,
  move: true,
  menu: true,
  showNumbers: 30,
  showPages: 10,
  total: null,
  lang: 'en',
  allSelect: true,
  rowCheck: false,
  focus: true,
  newBar: true,
  nodel: false
});

var inputStyle = {
  width: '80px'
};

var stopEvent = function stopEvent(e) {
  e.stopPropagation();
};

var _default = exports["default"] = CTable;
//# sourceMappingURL=CTable.js.map
