/* @clake/react-bootstrap4-window v1.0.9 | by Clake
 * Copyright (c) 2024 Clake,
 * 2024-08-23T10:03:50+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.TopMenu = exports.Item = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./css/TopMenu.less");

var _reactBootstrap = require("@clake/react-bootstrap4");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Item = exports.Item =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Item, _React$PureComponent);

  function Item(props) {
    var _this;

    _classCallCheck(this, Item);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Item).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "parent", void 0);

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "menu", void 0);

    _defineProperty(_assertThisInitialized(_this), "dom", void 0);

    _defineProperty(_assertThisInitialized(_this), "clickHandler", function (e) {
      if (typeof _this.props.onClick === 'function') {
        _this.props.onClick(_this.props.name);
      } else {
        if (_this.menu) {
          _this.parent.is_active = true;
          _this.parent.cur_active = _this.dom;
          _this.parent.cur_menu = _this.menu;

          _this.dom.classList.add('active');

          _this.menu.show({
            evt: e,
            type: 'dom-bottom',
            data: '',
            close: _this.closeHandler
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "changeActive", function (e) {
      if (_this.parent.is_active) {
        if (_this.parent.cur_active === _this.dom) return;

        if (_this.parent.cur_active) {
          _this.parent.cur_active.classList.remove('active');

          _this.parent.cur_menu.hide();
        }

        _this.clickHandler(e);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "closeHandler", function (e) {
      // console.log(e);
      // // console.log('close');
      // console.log(this.props.text);
      if (e) {
        if (_this.parent.cur_active) {
          _this.parent.cur_active.classList.remove('active');

          _this.parent.is_active = false;
          _this.parent.cur_menu = null;
        }
      }
    });

    _this.parent = _this.props.parent || null;
    _this.domId = 'topmenu-item-' + _reactBootstrap.Common.RandomString(16);
    return _this;
  }

  _createClass(Item, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-top-menu-item';
      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this2.dom = c;
        },
        id: this.domId,
        className: this.getClasses(),
        onMouseOver: this.changeActive,
        onClick: this.clickHandler
      }, this.props.text, _react["default"].Children.map(this.props.children, function (item) {
        item.props.parent = _this2;

        item.props.ref = function (c) {
          _this2.menu = c;
        };

        return _react["default"].cloneElement(item, item.props); // return item;
      }));
    }
  }]);

  return Item;
}(_react["default"].PureComponent);

var TopMenu = exports.TopMenu =
/*#__PURE__*/
function (_React$PureComponent2) {
  _inherits(TopMenu, _React$PureComponent2);

  function TopMenu(props) {
    var _this3;

    _classCallCheck(this, TopMenu);

    _this3 = _possibleConstructorReturn(this, _getPrototypeOf(TopMenu).call(this, props));

    _defineProperty(_assertThisInitialized(_this3), "cur_active", void 0);

    _defineProperty(_assertThisInitialized(_this3), "is_active", void 0);

    _defineProperty(_assertThisInitialized(_this3), "clickHandler", function (key) {
      if (typeof _this3.props.onClick === 'function') {
        _this3.props.onClick(key);
      }
    });

    _this3.cur_active = null;
    _this3.is_active = false;
    return _this3;
  }

  _createClass(TopMenu, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-top-menu d-flex border-bottom shadow';

      if (this.props.top) {
        base = (0, _classnames["default"])(base, 'ck-top-menu-top');
      }

      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      return _react["default"].createElement("div", {
        className: this.getClasses()
      }, _react["default"].Children.map(this.props.children, function (item) {
        item.props.parent = _this4;
        return _react["default"].cloneElement(item, item.props);
      }));
    }
  }]);

  return TopMenu;
}(_react["default"].PureComponent);

_defineProperty(TopMenu, "Item", Item);

var _default = exports["default"] = TopMenu;
//# sourceMappingURL=TopMenu.js.map
