/* @clake/react-bootstrap4-window v1.0.9 | by Clake
 * Copyright (c) 2024 Clake,
 * 2024-08-23T10:03:50+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.WModal = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactBootstrap = require("@clake/react-bootstrap4");

require("./css/WModal.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// const ModalAlert = 0;
// const ModalConfirm = 1;
// const ModalLoading = 2;
// const ModalView = 3;
//基础INDEX值
var BaseModal = 950;

var ModalTypes =
/*#__PURE__*/
function (ModalTypes) {
  ModalTypes[ModalTypes["ModalAlert"] = 0] = "ModalAlert";
  ModalTypes[ModalTypes["ModalConfirm"] = 1] = "ModalConfirm";
  ModalTypes[ModalTypes["ModalLoading"] = 2] = "ModalLoading";
  ModalTypes[ModalTypes["ModalView"] = 3] = "ModalView";
  return ModalTypes;
}(ModalTypes || {});

var defBtns = {
  ok: 'Ok',
  cancel: 'Cancel'
};

var WModal = exports.WModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(WModal, _React$Component);

  function WModal(props) {
    var _this;

    _classCallCheck(this, WModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WModal).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "offsetIndex", void 0);

    _defineProperty(_assertThisInitialized(_this), "is_open", void 0);

    _defineProperty(_assertThisInitialized(_this), "fadeTime", void 0);

    _defineProperty(_assertThisInitialized(_this), "modalType", void 0);

    _defineProperty(_assertThisInitialized(_this), "callback", void 0);

    _defineProperty(_assertThisInitialized(_this), "_main", void 0);

    _defineProperty(_assertThisInitialized(_this), "_shadow", void 0);

    _defineProperty(_assertThisInitialized(_this), "_dialog", void 0);

    _defineProperty(_assertThisInitialized(_this), "defaultProps", {
      center: false,
      width: '300px',
      fade: true
    });

    _defineProperty(_assertThisInitialized(_this), "closeHandler", function () {
      if (typeof _this.props.onClose === 'function') {
        _this.props.onClose();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "openHandler", function () {
      if (typeof _this.props.onOpen === 'function') {
        _this.props.onOpen();
      }
    });

    _this.state = {
      content: '',
      title: '',
      isCloseBtn: true,
      type: ModalTypes.ModalAlert,
      center: _this.props.center,
      fade: _this.props.fade,
      show: false,
      header: true,
      btns: defBtns,
      width: ''
    }; //modal type

    _this.modalType = ModalTypes.ModalAlert; //alert confirm callback function

    _this.callback = undefined;
    _this.domId = 'modal-' + _reactBootstrap.Common.RandomString(16);

    if (_this.props.id) {
      _this.domId = _this.props.id;
    }

    _this.offsetIndex = document.querySelectorAll(".modal").length * 10;
    _this.is_open = false;
    _this.fadeTime = {
      open: 0,
      close: 0
    };
    return _this;
  }

  _createClass(WModal, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state.content !== nextState.content;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {}
  }, {
    key: "open",
    value: function open() {
      var _this2 = this;

      if (this.is_open) {
        clearTimeout(this.fadeTime.open);
        clearTimeout(this.fadeTime.close);
      }

      this._main.classList.add('d-block');

      this.is_open = true;

      if (this.state.fade) {
        this.fadeTime.open = setTimeout(function () {
          _this2._shadow.classList.add('modal-show');

          _this2._dialog.style.opacity = '1';
          _this2._dialog.style.marginTop = '1.75rem';
        }, 150);
      }
    }
  }, {
    key: "close",
    value: function close() {
      var _this3 = this;

      if (this.state.fade) {
        this._dialog.style.opacity = '0';
        this._dialog.style.marginTop = '-1rem';

        this._shadow.classList.remove('modal-show');
      }

      this.fadeTime.close = setTimeout(function () {
        if (_this3 !== null && _this3 !== void 0 && _this3._main) {
          _this3._main.classList.remove('d-block');

          _this3.is_open = false;
        }
      }, 150);
    }
  }, {
    key: "alert",

    /**
     * modal alert method
     * opt example
     * {
     *      title: '',
     *      content: ''
     *      [,callback: func]
     * }
     * @param opt object
     */
    value: function alert(args, cb) {
      var _this4 = this;

      var opt;

      if (typeof args === 'string') {
        opt = {
          content: args
        };
      } else {
        opt = args;
      }

      this.callback = opt.callback || cb || undefined;
      this.modalType = ModalTypes.ModalAlert;
      this.setState({
        title: opt.title || 'Prompt',
        content: opt.content || opt || '',
        isCloseBtn: true,
        type: ModalTypes.ModalAlert,
        center: opt.center || this.props.center,
        fade: opt.fade || this.props.fade,
        header: typeof opt.header === 'undefined' ? true : opt.header,
        btns: typeof opt.btns != 'undefined' ? opt.btns : defBtns
      }, function () {
        _this4.open();
      });
    }
    /**
     * modal confirm method
     * opt example
     * {
     *      title:'',
     *      content:'',
     *      [callback: func]
     * }
     * @param opt
     */

  }, {
    key: "confirm",
    value: function confirm(args, cb) {
      var _this5 = this;

      var opt;

      if (typeof args === 'string') {
        opt = {
          content: args
        };
      } else {
        opt = args;
      }

      this.callback = opt.callback || cb || undefined;
      this.modalType = ModalTypes.ModalConfirm;
      this.setState({
        title: opt.title || 'Prompt',
        content: opt.content || '',
        isCloseBtn: true,
        type: ModalTypes.ModalConfirm,
        center: opt.center || this.props.center,
        fade: opt.fade || this.props.fade,
        header: typeof opt.header === 'undefined' ? true : opt.header,
        btns: typeof opt.btns != 'undefined' ? opt.btns : defBtns
      }, function () {
        _this5.open();
      });
    }
    /**
     * modal loading method
     * @param opt
     */

  }, {
    key: "loading",
    value: function loading(args) {
      var _this6 = this;

      var opt;

      if (typeof args === 'string') {
        opt = {
          content: args
        };
      } else {
        opt = args;
      }

      this.modalType = ModalTypes.ModalLoading;
      this.setState({
        title: opt.title || 'Prompt',
        // content:(
        //     <React.Fragment>
        //         <Icon icon='spinner'/>&nbsp;&nbsp;&nbsp;{content}
        //     </React.Fragment>
        // ),
        content: opt.content || opt || '',
        isCloseBtn: false,
        type: ModalTypes.ModalLoading,
        center: opt.center || this.props.center,
        fade: this.props.fade,
        header: opt.header || false
      }, function () {
        _this6.open();
      });
    }
    /**
     * modal view method
     * opt example
     * {
     *      title:'',
     *      content:flex,
     *      [callback:func]
     * }
     * @param opt
     */

  }, {
    key: "view",
    value: function view(opt) {
      var _this7 = this;

      this.callback = opt.callback || undefined;
      this.modalType = ModalTypes.ModalView;
      this.setState({
        title: opt.title || 'Prompt',
        content: opt.content || '',
        isCloseBtn: true,
        type: ModalTypes.ModalView,
        center: opt.center || this.props.center,
        fade: opt.fade || this.props.fade,
        header: typeof opt.header === 'undefined' ? true : opt.header
      }, function () {
        _this7.open();
      });
    }
  }, {
    key: "getMainClasses",
    value: function getMainClasses() {
      var base = 'wmodal-main';

      if (this.state.fade) {
        base = (0, _classnames["default"])(base, 'wmodal-fade');
      }

      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'modal wmodal-sm d-block';

      if (this.modalType === ModalTypes.ModalView) {
        base = (0, _classnames["default"])(base, "bd-example-modal-lg");
      }

      if (this.state.fade) {
        base = (0, _classnames["default"])(base, 'wmodal-fade');
      }

      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "getDialogStyles",
    value: function getDialogStyles() {
      var base = {};

      if (this.state.width) {
        base.maxWidth = this.state.width;
      } else if (this.props.width) {
        base.maxWidth = this.props.width;
      }

      return base;
    }
  }, {
    key: "getDialogClasses",
    value: function getDialogClasses() {
      var base = 'modal-dialog';

      if (this.modalType === ModalTypes.ModalView) {
        base = (0, _classnames["default"])(base, "modal-lg");
      }

      if (this.state.center) {
        base = (0, _classnames["default"])(base, "modal-dialog-centered");
      }

      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "getShadowClasses",
    value: function getShadowClasses() {
      var base = 'modal-backdrop ck-modal-shadow show';
      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "renderFooter",
    value: function renderFooter() {
      var _this8 = this;

      var content = null;

      switch (this.state.type) {
        case ModalTypes.ModalAlert:
          content = _react["default"].createElement(_reactBootstrap.Button, {
            className: "w-100",
            size: "sm",
            "data-dismiss": "modal",
            onClick: function onClick(e) {
              _this8.close();

              if (typeof _this8.callback === 'function') {
                _this8.callback(1);
              }
            }
          }, this.state.btns['ok']);
          break;

        case ModalTypes.ModalConfirm:
          content = _react["default"].createElement("div", {
            className: "row flex-grow-1 g-1 btn"
          }, _react["default"].createElement(_reactBootstrap.ButtonGroup, null, _react["default"].createElement(_reactBootstrap.Button, {
            className: "col-6",
            size: "sm",
            onClick: function onClick() {
              _this8.close();

              if (typeof _this8.callback === 'function') {
                _this8.callback(1);
              }
            }
          }, this.state.btns['ok']), _react["default"].createElement(_reactBootstrap.Button, {
            className: "col-6",
            size: "sm",
            onClick: function onClick() {
              _this8.close();

              if (typeof _this8.callback === 'function') {
                _this8.callback(0);
              }
            },
            theme: "secondary"
          }, this.state.btns['cancel'])));
          break;

        default:
          return null;
      }

      return _react["default"].createElement("div", {
        className: "modal-footer"
      }, content);
    }
  }, {
    key: "render",
    value: function render() {
      var _this9 = this;

      var modalIndex = {
        zIndex: BaseModal + this.offsetIndex + 2
      };
      var shadowIndex = {
        zIndex: BaseModal + this.offsetIndex + 1
      };
      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this9._main = c;
        },
        className: this.getMainClasses()
      }, _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this9._shadow = c;
        },
        className: this.getShadowClasses(),
        style: shadowIndex,
        id: "".concat(this.domId, "-shadow")
      }), _react["default"].createElement("div", {
        className: this.getClasses(),
        style: modalIndex,
        tabIndex: -1,
        id: this.domId,
        role: "dialog"
      }, _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this9._dialog = c;
        },
        className: this.getDialogClasses(),
        style: this.getDialogStyles(),
        role: "document"
      }, _react["default"].createElement("div", {
        className: "modal-content"
      }, this.state.header ? _react["default"].createElement("div", {
        className: "modal-header"
      }, _react["default"].createElement("h6", {
        className: "modal-title"
      }, this.state.title), this.state.isCloseBtn ? _react["default"].createElement("button", {
        type: "button",
        className: "btn-close",
        onClick: function onClick() {
          _this9.close();
        }
      }) : null) : null, _react["default"].createElement("div", {
        className: "modal-body"
      }, this.state.type === ModalTypes.ModalLoading ? _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_reactBootstrap.Load, null), "\xA0\xA0\xA0", this.state.content) : this.state.content), this.renderFooter()))));
    }
  }]);

  return WModal;
}(_react["default"].Component);

var _default = exports["default"] = WModal;
//# sourceMappingURL=WModal.js.map
