/** @module react-bootstrap-v4-window/CTable */
import React from 'react';
import { Menu, CCheckbox, ComponentProps } from '@clake/react-bootstrap4';
import './css/CTable.less';
import Drag from "./Drag";
interface Props extends ComponentProps {
    theme?: string;
    headerTheme?: string;
    headClass?: string;
    data?: any[];
    dataCount?: number;
    page?: number;
    select?: boolean;
    selectOnce?: boolean;
    header?: boolean;
    center?: boolean;
    currentPage?: number;
    striped?: boolean;
    bordered?: boolean;
    hover?: boolean;
    sm?: boolean;
    fontSm?: boolean;
    responsive?: boolean;
    align?: string;
    tree?: string;
    onClickTree?: () => void;
    onClick?: (row: any, idx: number, id?: string) => void;
    onCheck?: (chk: boolean, row: any, id?: string) => void;
    onCheckAll?: (chk: boolean, data: any[], id?: string) => void;
    onFilter?: (text: string, field: string, type: string, id?: string) => void;
    onSort?: (field: string, sort_type: string, id?: string) => void;
    move?: boolean;
    onRefresh?: () => void;
    refreshText?: string;
    absolute?: boolean;
    x?: string;
    y?: string;
    width?: string;
    height?: string;
    foot?: any;
    position?: any;
    showPages?: number;
    showNumbers?: number;
    onSelectPage?: (page: number, id?: string) => void;
    noWrap?: boolean;
    menu?: boolean;
    total?: any;
    edit?: boolean;
    newBar?: boolean;
    nodel?: boolean;
    onDelete?: (row: any, idx: number, callback: (row_index: number) => void, id?: string) => void;
    sort?: boolean;
    filter?: boolean;
    customMenu?: any;
    lang?: any;
    source?: string;
    sourceFunc?: (opt: any, callback: (res: any) => void) => void;
    allSelect?: boolean;
    focus?: boolean;
    rowCheck?: boolean;
    columnStyle?: any;
    jsxId?: string;
}
interface State {
    data: any[];
    dataCount: number;
    page: number;
    select: boolean;
    total: any;
    filter: any;
    selectAll: boolean;
    selectHalf: boolean;
    selectRows: any[];
    focus: number;
}
export declare class CTable extends React.Component<Props, State> {
    static defaultProps: Props;
    originalData: any[];
    domId: string;
    select_all: boolean;
    selectRows: any[];
    headerSplits: any;
    sortList: any;
    is_sort: boolean;
    is_filter: boolean;
    current_sort: any;
    filter_list: any[];
    editRows: any[];
    cacheRow: any;
    headers: any;
    noClone: any;
    lockColumns: any[];
    isLock: boolean;
    filter: any;
    width: string;
    tableHeader: HTMLElement;
    tableTotal: HTMLElement;
    table_rows: HTMLElement;
    table_head: HTMLElement;
    table_body: HTMLElement;
    table_total: HTMLElement;
    fullButton: HTMLElement;
    split: HTMLElement;
    mainDom: HTMLElement;
    mainMenu: Menu;
    numMenu: Menu;
    drag: Drag;
    dragColumnLeft: number;
    dragWidth: number;
    allchk: CCheckbox;
    isFull: boolean;
    constructor(props: any);
    componentDidMount(): void;
    UNSAFE_componentWillReceiveProps(nextProps: Props): void;
    shouldComponentUpdate(nextProps: Props, nextState: State): boolean;
    equals: (a: any, b: any) => boolean;
    initTableWidth(): void;
    sourceLoad(): void;
    sourceFilter(): ({
        field: any;
        value: any;
        flag: string;
    } | undefined)[];
    sourceOrder(): void;
    changeHandler(row: any, i: number): (checked: boolean, e: any) => void;
    checkAllCheckHalf(selectRows: Array<any>): boolean[];
    setRowCheck(checked: boolean, rowIdx: number): any[];
    selectAll: (checked: boolean) => void;
    clickHandler(row: any, i: number): () => void;
    /**
     * sort
     */
    sortHandler: (e: any) => void;
    changeSort(dom: HTMLElement, sort_type: string): void;
    clearSort(emitEvt: any): boolean | undefined;
    localSort(field: string, sort_type: string): void;
    /**
     * scroll header and total foot
     * @param e
     */
    scrollHandler: (e: any) => void;
    /**
     * show menu list
     * @param dataType
     */
    menuContextHandler(dataType: string): (e: any) => void;
    menuClickHandler: (field: string, data: any) => void;
    /**
     * filter
     * */
    localFilter(text: string, field: string, type: string): void;
    filterHandler(text: string, field: string, type: string): void;
    clearFilter(): void;
    filterChangeHandler(field: string): (val: any) => void;
    selectPageHandler: (page: number) => void;
    /**
     * edit mode
     */
    addNewHandler: (e: any) => void;
    editHandler: (e: any, val: any, row: any) => void;
    editCallback: (index: number, editData: any) => void;
    getEditRows(): any[];
    clearEditRows(): void;
    deleteRowHandler(row_index: number): void;
    deleteRow(row_index: number): void;
    cloneRow(row_index: number): void;
    fullHandler: () => void;
    /**
     * 得到所有选中的行
     */
    getSelectRows(): any[];
    /**
     * 设置选中的行
     */
    setSelectRows(key: string, list: any[]): void;
    /**
     * binding column split
     */
    bindSplit(): void;
    getClasses(name?: string): string;
    getMainClasses(): string;
    getStyles(): any;
    getHeaderClasses(): string;
    getTableStyles(style?: any): any;
    getBodyClasses(): string;
    calcLocalTotal(field: string): (e: any) => void;
    render(): JSX.Element;
    renderHeader(): JSX.Element;
    renderRows(): JSX.Element;
    renderRow(row: any, i: number, parentRow?: any): JSX.Element;
    renderEditRow(row: any, i: number): JSX.Element;
    renderEditAddRow(): JSX.Element;
    renderEditComponent(item: any, row: any, i: number): JSX.Element;
    renderFoot(): JSX.Element | null;
    renderTotal(): JSX.Element | null;
    renderMenu(): JSX.Element;
    renderNumberMenu(): JSX.Element;
    explainCustomMenu(menu: any): JSX.Element;
}
export default CTable;
//# sourceMappingURL=CTable.d.ts.map