/** @module react-bootstrap-v4-window/WModal */
import React from 'react';
import { ComponentProps, StrObject, AnyObject } from '@clake/react-bootstrap4';
import './css/WModal.less';
export interface ModalOptions {
    content?: any;
    title?: any;
    isCloseBtn?: boolean;
    type?: number;
    callback?: () => void;
    center?: boolean;
    fade?: boolean;
    header?: boolean;
    btns?: StrObject;
}
interface Props extends ComponentProps {
    onOpen: () => void;
    onClose: () => void;
    center: boolean;
    fade: boolean;
    blurSelector: string;
    width: string;
}
interface State {
    content: string;
    title: string;
    isCloseBtn: boolean;
    type: number;
    center: boolean;
    fade: boolean;
    show: boolean;
    header: boolean;
    btns: StrObject;
    width: string;
}
export declare class WModal extends React.Component<Props, State> {
    domId: string;
    offsetIndex: number;
    is_open: boolean;
    fadeTime: AnyObject;
    modalType: number;
    callback?: (flag?: any) => void;
    _main: HTMLDivElement;
    _shadow: HTMLDivElement;
    _dialog: HTMLDivElement;
    defaultProps: {
        center: boolean;
        width: string;
        fade: boolean;
    };
    constructor(props: any);
    shouldComponentUpdate(nextProps: Props, nextState: State): boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    open(): void;
    close(): void;
    closeHandler: () => void;
    openHandler: () => void;
    /**
     * modal alert method
     * opt example
     * {
     *      title: '',
     *      content: ''
     *      [,callback: func]
     * }
     * @param opt object
     */
    alert(args: ModalOptions | string, cb?: () => void): void;
    /**
     * modal confirm method
     * opt example
     * {
     *      title:'',
     *      content:'',
     *      [callback: func]
     * }
     * @param opt
     */
    confirm(args: ModalOptions | string, cb?: () => void): void;
    /**
     * modal loading method
     * @param opt
     */
    loading(args: ModalOptions | string): void;
    /**
     * modal view method
     * opt example
     * {
     *      title:'',
     *      content:flex,
     *      [callback:func]
     * }
     * @param opt
     */
    view(opt: ModalOptions): void;
    getMainClasses(): string;
    getClasses(): string;
    getDialogStyles(): any;
    getDialogClasses(): string;
    getShadowClasses(): string;
    renderFooter(): JSX.Element | null;
    render(): JSX.Element;
}
export default WModal;
//# sourceMappingURL=WModal.d.ts.map